/** \file evenParity.h
 * Exported function: evenParity().
*/
#ifndef EVENPARITY_H
#define EVENPARITY_H

#include "mixedGraph.h"

/** Makes the degree of each node even while preserving indegree==outdegree.
 * This function takes as arguments a mixed graph of type
 * MixedGraph<NodeInfo,EdgeInfo> which is output of algorithm ::inoutdegree,
 * and a directed graph extraCopies of type GRAPH<node,int> which is created
 * by algorithm inoutdegree.
 * 
 * After its termination, for graph will hold the following:
 * The degree of each node is even, and indegree equals outdegree
 * in each node.
 * \param graph A reference to a mixed graph.
 * \param extraCopies A reference to the graph extraCopies produced by algorithm inoutdegree.
 * \return 0, if it worked
 */
int evenParity(MixedGraph<NodeInfo,EdgeInfo>& graph, GRAPH<node,int>& extraCopies);


#endif
