
template<class T>
inline SymMatrix<T>::SymMatrix(int n)
 : dim(n), size((dim*(dim+1))/2), start(new T[size]) {
}


template<class T>
inline SymMatrix<T>::SymMatrix(const SymMatrix<T>& M) {
   dim = M.dim;
   start = new T[size];
   for (int i=0; i<size; i++)
      start[i] = M.start[i];
}


template<class T>
inline void SymMatrix<T>::init(const T& wert) {
   for (int i=0; i<size; i++)
      start[i] = wert;
}


template<class T>
inline SymMatrix<T>::~SymMatrix() {
   delete [] start;
}


template<class T>
inline int SymMatrix<T>::getDim() const {
   return(dim);
}


template<class T>
inline SymMatrix<T>& SymMatrix<T>::operator=(const SymMatrix<T>& M) {
   if (this != &M) {
      delete [] start;
      dim = M.dim;
      start = new T[size];
      for (int i=0; i<size; i++)
         start[i] = M.start[i];
   }
   return *this;
}


template<class T>
inline int SymMatrix<T>::indexShift(int i, int j) const {
   if (i<=j)
      return (i*(2*dim-i-1))/2+j;
   return indexShift(j,i);
}


template<class T>
inline T& SymMatrix<T>::at(int i, int j) {
   return start[indexShift(i,j)];
}


template<class T>
inline const T& SymMatrix<T>::at(int i, int j) const {
   return start[indexShift(i,j)];
}
   


template<class T>
inline void SymMatrix<T>::setDiag(const T& wert) {
   for (int i=0; i<dim; i++)
      at(i,i) = wert;
}




